## ants 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)
cmake_policy(VERSION 2.8.5)

set(LIBRARY_SOVERSION_INFO 2)
set(LIBRARY_VERSION_INFO 2.1.0)

set(LOCAL_PROJECT_NAME ANTS)
INCLUDE(InstallRequiredSystemLibraries)
## NOTE THERE SHOULD BE NO PROJECT STATEMENT HERE!
## This file acts as a simple switch to initiate
## two completely independant CMake build environments.

#-----------------------------------------------------------------------------
# Superbuild Option - Enabled by default
#                   Phase I:  ${LOCAL_PROJECT_NAME}_SUPERBUILD is set to ON, and the
#                             supporting packages defined in "SuperBuild.cmake"
#                             are built.  The last package in "SuperBuild.cmake"
#                             to be built is a recursive call to this
#                             file with ${LOCAL_PROJECT_NAME}_SUPERBUILD explicitly
#                             set to "OFF" to initiate Phase II
#
#                   Phase II: Build the ${LOCAL_PROJECT_NAME}, referencing the support
#                             packages built in Phase I.
#-----------------------------------------------------------------------------
option(${LOCAL_PROJECT_NAME}_SUPERBUILD "Build ${LOCAL_PROJECT_NAME} and the projects it depends on via SuperBuild.cmake." ON)
mark_as_advanced(${LOCAL_PROJECT_NAME}_SUPERBUILD)

option(${LOCAL_PROJECT_NAME}_USE_QT "Find and use Qt with VTK to build GUI Tools" OFF)
mark_as_advanced(${LOCAL_PROJECT_NAME}_USE_QT)

option(${LOCAL_PROJECT_NAME}_INSTALL_DEVELOPMENT "Install development support include and libraries for external packages." OFF)
mark_as_advanced(${LOCAL_PROJECT_NAME}_INSTALL_DEVELOPMENT)

set(CPACK_PACKAGE_NAME "ANTs")
set(CPACK_PACKAGE_VENDOR "CMake.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - Advanced Normalization Tools")
set(CPACK_PACKAGE_VERSION 2.1.0)
set(CPACK_PACKAGE_VERSION_MAJOR 2)
set(CPACK_PACKAGE_VERSION_MINOR 1)
set(CPACK_PACKAGE_VERSION_PATCH 0)
set(CPACK_PACKAGE_INSTALL_DIRECTORY "ANTS_Install")
set(CPACK_BINARY_GENERATORS "DragNDrop TGZ TZ")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - robust image registration, segmentation and more")
set(CPACK_RESOURCE_FILE_LICENSE  "${CMAKE_CURRENT_SOURCE_DIR}/ANTSCopyright.txt")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
#-----------------------------------------------------------------------------
# Superbuild script
#-----------------------------------------------------------------------------
if(${LOCAL_PROJECT_NAME}_SUPERBUILD)
  project(SuperBuild_${LOCAL_PROJECT_NAME})
  include("${CMAKE_CURRENT_SOURCE_DIR}/SuperBuild.cmake")
  include(CPack)   # This must always be last!
  return()
else()
  project(${LOCAL_PROJECT_NAME})
  include("${CMAKE_CURRENT_SOURCE_DIR}/${LOCAL_PROJECT_NAME}.cmake")
  include(CPack)   # This must always be last!
  return()
endif()

message(FATAL_ERROR "You should never reach this point !")

=== Examples/CMakeLists.txt ===
set(PICSL_INCLUDE_DIRS
../Utilities
../ImageRegistration
../ImageSegmentation
../GraphTheory
../Tensor
../Temporary
.
)

include_directories( ${BOOST_INCLUDE_DIR} ) #Define where to find Boost includes
include_directories(${PICSL_INCLUDE_DIRS})
link_directories( ${ITK_LIBRARY_PATH}  )
# message("${ITK_LIBRARIES}")
# non-templated class -- this should be stored in a library and linked in...
set(UI_SOURCES "../Utilities/antsCommandLineParser" "../Utilities/antsCommandLineOption" )

include_directories(${CMAKE_CURRENT_BINARY_DIR})
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ANTsVersionConfig.h.in"
               "${CMAKE_CURRENT_BINARY_DIR}/ANTsVersionConfig.h" @ONLY IMMEDIATE)

## Note that the antsUtilities can always be built static.  It will then be linked
## Directly into the other libraries.
add_library(antsUtilities STATIC antsUtilities.cxx ../Utilities/ReadWriteData.cxx
            antsRegistrationTemplateHeader.cxx
            antsRegistration2DDouble.cxx antsRegistration2DFloat.cxx
            antsRegistration3DDouble.cxx antsRegistration3DFloat.cxx
            antsRegistration4DDouble.cxx antsRegistration4DFloat.cxx
            ANTsVersion.cxx
            )
target_link_libraries(antsUtilities ${ITK_LIBRARIES} )

macro(STANDARD_ANTS_BUILD ANTS_FUNCTION_NAME EXTRA_LIBS)
  set( ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME} )

  add_library(l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}.cxx ${UI_SOURCES})
  SET_TARGET_PROPERTIES(l_${ANTS_FUNCTION_NAME} PROPERTIES
    SOVERSION ${LIBRARY_SOVERSION_INFO}  VERSION ${LIBRARY_VERSION_INFO})
  message(STATUS "${ANTS_FUNCTION_NAME} ${EXTRA_LIBS}")
  target_link_libraries(l_${ANTS_FUNCTION_NAME} antsUtilities ${ITK_LIBRARIES} ${EXTRA_LIBS} )
  configure_file( template_for_executables.cxx.in cli_${ANTS_FUNCTION_NAME}.cxx )
  add_executable( ${ANTS_FUNCTION_NAME} cli_${ANTS_FUNCTION_NAME}.cxx )
  target_link_libraries( ${ANTS_FUNCTION_NAME} l_${ANTS_FUNCTION_NAME})

  install(TARGETS l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
  )

endmacro()

#set(PROG_WITH_NO_FLAG simpleSynRegistration)
#add_executable(${PROG_WITH_NO_FLAG} ${PROG_WITH_NO_FLAG}.cxx)
#target_link_libraries(${PROG_WITH_NO_FLAG} antsUtilities ${ITK_LIBRARIES})

set(BASE_ANTS_APPS
  ANTS
  ANTSJacobian
  PrintHeader
  ResetDirection
  # ResetDirection2
  # BoykovGraphCutFilter
  # GeneralLinearModel
  ANTSUseLandmarkImagesToGetAffineTransform
  ANTSUseLandmarkImagesToGetBSplineDisplacementField
  ANTSUseDeformationFieldToGetAffineTransform
  # FDR
  antsAffineInitializer
  # antsSimilarityInitializer
  ImageMath
  SurfaceCurvature
  SurfaceBasedSmoothing
  # test
  # WarpImage
  LaplacianThickness
  SetOrigin
  SetSpacing
  SetDirectionByMatrix
  # WarpFunctionalImage
  ConvertScalarImageToRGB
  CreateWarpedGridImage
  CreateJacobianDeterminantImage
  MeasureImageSimilarity
  ConvertToJpg
  ConvertImagePixelType
  ConvertInputImagePixelTypeToFloat
  FitBSplineCurveToPoints
  AverageImages
  AverageTensorImages
  ImageSetStatistics
  ThresholdImage
  MultiplyImages
  SmoothImage
  ClusterImageStatistics
  LabelClustersUniquely
  # StudentsTestOnImages
  LabelOverlapMeasures
  LesionFilling
  MeasureMinMaxMean
  WarpImageMultiTransform
  ComposeMultiTransform
  StackSlices
  MemoryTest
  # ANTSOrientImage
  PermuteFlipImageOrientationAxes
  ImageCompare
  ResampleImageBySpacing
  # ResampleImageByOtherImage
  CopyImageHeaderInformation
  WarpTimeSeriesImageMultiTransform
  ResampleImage
  ExtractSliceFromImage
  ExtractRegionFromImage
  ExtractRegionFromImageByMask
  LabelGeometryMeasures
  PasteImageIntoImage
  TileImages
  CreateTiledMosaic
  CreateImage
  WarpTensorImageMultiTransform
  ReorientTensorImage
  RebaseTensorImage
  N3BiasFieldCorrection
  N4BiasFieldCorrection
  KellySlater
  KellyKapowski
  CreateDTICohort
  AverageAffineTransform
  AverageAffineTransformNoRigid
  antsAlignOrigin
  antsRegistration
  simpleSynRegistration
  antsApplyTransforms
  antsApplyTransformsToPoints
  CompositeTransformUtil
  antsMotionCorr
  antsMotionCorrStats
  antsMotionCorrDiffusionDirection
  antsSliceRegularizedRegistration
  sccan
  CreateDisplacementField
  ANTSIntegrateVectorField
  ANTSIntegrateVelocityField
  Atropos
  ConvertTransformFile
  compareTwoTransforms
  TimeSCCAN
  TextureCooccurrenceFeatures
  TextureRunLengthFeatures
  ImageIntensityStatistics
  GetConnectedComponentsFeatureImages
  DeNrrd
  antsTransformInfo
  antsUtilitiesTesting
)
foreach(ANTS_APP ${BASE_ANTS_APPS})
  STANDARD_ANTS_BUILD(${ANTS_APP} "")
endforeach()

if(USE_VTK)
find_package(VTK 6.2 REQUIRED NO_MODULE)
find_package(VTK COMPONENTS
   vtkCommonCore
   vtkCommonDataModel
   vtkIOGeometry
   vtkIOXML
   vtkIOLegacy
   vtkIOPLY
   vtkRenderingOpenGL
   vtkFiltersModeling
   vtkImagingStencil
   vtkImagingGeneral
   vtkRenderingAnnotation
   )
include(${VTK_USE_FILE})
include_directories(${VTK_INCLUDE_DIRS})

set(VTK_ANTS_APPS
#    ConvertVectorFieldToVTK
    antsSurf
    GetMeshAndTopology
    CheckTopology
    WarpVTKPolyDataMultiTransform
    # FLATFEM
    # ConformalMapping
    # ANTSConformalMapping
  )

foreach(ANTS_APP ${VTK_ANTS_APPS})
  STANDARD_ANTS_BUILD(${ANTS_APP} "${VTK_LIBRARIES}")
endforeach()
endif(USE_VTK)

install(PROGRAMS ../Scripts/ANTSpexec.sh
     ../Scripts/antsASLProcessing.sh
     ../Scripts/antsAtroposN4.sh
     ../Scripts/antsBOLDNetworkAnalysis.R
     ../Scripts/antsBrainExtraction.sh
     ../Scripts/antsCorticalThickness.sh
     ../Scripts/antsIntermodalityIntrasubject.sh
     ../Scripts/antsIntroduction.sh
     ../Scripts/antsLaplacianBoundaryCondition.R
     ../Scripts/antsLongitudinalCorticalThickness.sh
     ../Scripts/antsMalfLabeling.sh
     ../Scripts/antsMultivariateTemplateConstruction.sh
     ../Scripts/antsMultivariateTemplateConstruction2.sh
     ../Scripts/antsNetworkAnalysis.R
     ../Scripts/antsNeuroimagingBattery
     ../Scripts/antsRegistrationSyN.sh
     ../Scripts/antsRegistrationSyNQuick.sh
     ../Scripts/waitForPBSQJobs.pl
     ../Scripts/waitForSGEQJobs.pl
     ../Scripts/waitForXGridJobs.pl
                DESTINATION bin
                PERMISSIONS  OWNER_WRITE OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
                CONFIGURATIONS  Release
        )


## Build test option
if(BUILD_TESTING)
    add_subdirectory(TestSuite)
endif(BUILD_TESTING)

# Copy all the shell scripts in the Scripts/ directory to the bin directory
##
option( COPY_SCRIPT_FILES_TO_BIN_DIR "Copy the script files to the ANTS bin directory." ON )
if( COPY_SCRIPT_FILES_TO_BIN_DIR )
  file( GLOB SCRIPT_FILES "${CMAKE_SOURCE_DIR}/../Scripts/*.sh" )
  file( GLOB PSCRIPT_FILES "${CMAKE_SOURCE_DIR}/../Scripts/*.pl" )
  foreach( SCRIPT_FILE ${SCRIPT_FILES} )
    add_custom_command( TARGET ANTS POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy ${SCRIPT_FILE} ${CMAKE_BINARY_DIR} )
  endforeach( SCRIPT_FILE )
  foreach( SCRIPT_FILE ${PSCRIPT_FILES} )
    add_custom_command( TARGET ANTS POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy ${SCRIPT_FILE} ${CMAKE_BINARY_DIR} )
  endforeach( SCRIPT_FILE )
endif( COPY_SCRIPT_FILES_TO_BIN_DIR )
set(CPACK_PACKAGE_NAME "ANTs")
set(CPACK_PACKAGE_VENDOR "CMake.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - Advanced Normalization Tools")
set(CPACK_PACKAGE_VERSION 2.1.0)
set(CPACK_PACKAGE_VERSION_MAJOR 2)
set(CPACK_PACKAGE_VERSION_MINOR 1)
set(CPACK_PACKAGE_VERSION_PATCH 0)
set(CPACK_PACKAGE_INSTALL_DIRECTORY "ANTS")
set(CPACK_BINARY_GENERATORS "DragNDrop TGZ TZ")
# This must always be last!
include(CPack)

=== Examples/TestSuite/CMakeLists.txt ===
###############################################################################
###############################################################################
## MakeTestDriverFromANTSbinary
## For tools made with the slicer execution model,
## This macro will build a test driver that adds the
## --compare
## --compareIntensityTolerance
## --compareRadiusTolerance
## --compareNumberOfPixelsTolerance
## to the SEM tools.
macro(MakeTestDriverFromANTSbinary ANTSbinaryName ANTSbinaryTestSourceName ANTS_FUNCTION_NAME)

  set(CMAKE_TESTDRIVER_BEFORE_TESTMAIN "#include \"itkTestDriverBeforeTest.inc\"")
  set(CMAKE_TESTDRIVER_AFTER_TESTMAIN "#include \"itkTestDriverAfterTest.inc\"")

  set(ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME})
  configure_file( template_for_executableTestWrapper.cxx.in ${ANTSbinaryTestSourceName} )

  include_directories(${ITK_INCLUDE_DIRS})
  create_test_sourcelist(${ANTSbinaryName}   ${ANTSbinaryName}Driver.cxx ${ANTSbinaryTestSourceName}
     EXTRA_INCLUDE itkTestDriverIncludeRequiredIOFactories.h
     FUNCTION  ProcessArgumentsAndRegisterRequiredFactories
     )

  add_executable(${ANTSbinaryName}Driver ${ANTSbinaryName}Driver.cxx ${ANTSbinaryTestSourceName})
  target_link_libraries(${ANTSbinaryName}Driver l_${ANTS_FUNCTION_NAME} )
  set_target_properties(${ANTSbinaryName}Driver PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
endmacro(MakeTestDriverFromANTSbinary ANTSbinaryName)

#-----------------------------------------------------------------------
# Setup locations to find externally maintained test data.
#-----------------------------------------------------------------------
include(ANTSExternalData)

# Tell ExternalData commands to transform raw files to content links.
set(ExternalData_LINK_CONTENT MD5)
set(ExternalData_SOURCE_ROOT ${${PROJECT_NAME}_SOURCE_DIR})
include(ExternalData)


# Set testing environment
set(ANTS_TEST_BIN_DIR ${CMAKE_BINARY_DIR}/Examples)

set(TEST_DATA_DIR ${CMAKE_SOURCE_DIR}/TestData)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/TEST_LOCATION)

## Test antsRegistration
##
file(GLOB_RECURSE INCS ${CMAKE_SOURCE_DIR}/Examples/"*.h")

MakeTestDriverFromANTSbinary(antsRegistrationTest antsRegistrationTest.cxx antsRegistration)
MakeTestDriverFromANTSbinary(ANTSTest ANTSTest.cxx ANTS)
MakeTestDriverFromANTSbinary(WarpImageMultiTransform WarpImageMultiTransformTest.cxx WarpImageMultiTransform)
MakeTestDriverFromANTSbinary(simpleSynRegistrationTest simpleSynRegistrationTest.cxx simpleSynRegistration)
MakeTestDriverFromANTSbinary(antsApplyTransformsTest antsApplyTransformsTest.cxx antsApplyTransforms)
MakeTestDriverFromANTSbinary(CompositeTransformUtilTest CompositeTransformUtilTest.cxx CompositeTransformUtil)
MakeTestDriverFromANTSbinary(compareTwoTransformsTest compareTwoTransformsTest.cxx compareTwoTransforms)



###
#  Perform testing
###
set(TestDataMD5_DIR ${CMAKE_SOURCE_DIR}/TestData)
set(SMALL_DATA_DIR ${TestDataMD5_DIR}/Data)

ExternalData_expand_arguments(${PROJECT_NAME}FetchData R16_IMAGE DATA{${SMALL_DATA_DIR}/r16slice.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData R64_IMAGE DATA{${SMALL_DATA_DIR}/r64slice.nii.gz})
###
# PSE sub-tests:  Check to see if .txt files and .vtk files also run correctly
###
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE DATA{${SMALL_DATA_DIR}/Frown.nii})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE DATA{${SMALL_DATA_DIR}/Smile.nii})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE_TXT DATA{${SMALL_DATA_DIR}/Frown.txt})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE_TXT DATA{${SMALL_DATA_DIR}/Smile.txt})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE_VTK DATA{${SMALL_DATA_DIR}/Frown.vtk})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE_VTK DATA{${SMALL_DATA_DIR}/Smile.vtk})
#ExternalData_expand_arguments(${PROJECT_NAME}FetchData SEG_IMAGE DATA{${SMALL_DATA_DIR}/nslice.nii.gz})

if(RUN_LONG_TESTS)

## A work around for the crazy ANTS command line that is not compatible
## with the testing framework of external tests

ExternalData_expand_arguments(${PROJECT_NAME}FetchData test_mask_VAR DATA{${TestDataMD5_DIR}/test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData scale_test_mask_VAR DATA{${TestDataMD5_DIR}/scale.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_test_mask_VAR DATA{${TestDataMD5_DIR}/rotation.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_test_mask_VAR DATA{${TestDataMD5_DIR}/translation.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData test_image_VAR DATA{${TestDataMD5_DIR}/test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData scale_test_image_VAR DATA{${TestDataMD5_DIR}/scale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_test_image_VAR DATA{${TestDataMD5_DIR}/rotation.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_geom_test_image_VAR DATA{${TestDataMD5_DIR}/rotation.geom.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_test_image_VAR DATA{${TestDataMD5_DIR}/translation.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_rescale_test_image_VAR DATA{${TestDataMD5_DIR}/translation.rescale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_rescale_test_image_VAR DATA{${TestDataMD5_DIR}/rotation.rescale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANON0006_20_T1_dbg_splayed_image_VAR DATA{${TestDataMD5_DIR}/ANON0006_20_T1_dbg_splayed.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANON0006_20_T1_sag_twisted_image_VAR DATA{${TestDataMD5_DIR}/ANON0006_20_T1_sag_twisted.nii.gz})

set(antsRegistrationTestName antsRegistrationTest_AffineScaleMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 9
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 1000

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5 #numberOfIterations 2500
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${scale_test_image_VAR},1,200,Regular,0.10] #costMetric & fixedVolume & movingVolume & metricWeight? & numberOfHistogramBins & samplingStrategy? & samplingPercentage(numberOfSamples)
  --transform "Affine[0.001]" #transformType & minimumStepLength
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --masks [${test_mask_VAR},${scale_test_mask_VAR}] #fixedBinaryVolume & movingBinaryVolume
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz,${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}_inverse.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineScaleNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 9
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 1000

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  -u
  --metric Mattes[${test_image_VAR},${scale_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]" #transformType & minimumStepLength
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_0.05_antsRegistrationTest_AffineScaleMasks.mat}
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineRotationMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${rotation_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --masks [${test_mask_VAR},${rotation_test_mask_VAR}]
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineRotationNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${rotation_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineTranslationMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric MeanSquares[${test_image_VAR},${translation_test_image_VAR},1,radius=NA,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataMD5_DIR}/Initializer_${antsRegistrationTestName}.mat}
  --masks [${test_mask_VAR},${translation_test_mask_VAR}]
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineTranslationNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} $<TARGET_FILE:antsRegistrationTestDriver>
  --compare DATA{${TestDataMD5_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1

=== debian/changelog ===
ants (2.1.0-2~nd14.04+1) trusty; urgency=medium

  * Backported for trusty.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Tue, 27 Oct 2015 16:23:42 -0400

ants (2.1.0-2) unstable; urgency=medium

  * Upload to unstable
  * debian/rules
    - specify CMAKE_INSTALL_RPARTH
    - symlink into /usr/bin other tools which shouldn't conflict in names

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 27 Oct 2015 09:24:51 -0400

ants (2.1.0-1) experimental; urgency=medium

  * New upstream release
    - requires ITK >= 4.7 (debian/control adjusted)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 13 Feb 2015 00:12:03 -0500

=== debian/control ===
Source: ants
Section: science
Priority: extra
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 9),
               help2man, cmake,
               libopenjpeg-dev, libinsighttoolkit4-dev (>> 4.7.0~), uuid-dev,
               tcl-vtk | libvtk5-dev (<< 5.8),
               python-vtk | libvtk5-dev (<< 5.8),
               libvtk-java | libvtk5-dev (<< 5.8),
               libvtk5.8-qt4 | libvtk5-dev (<< 5.8),
               libboost-dev,
               libtiff-dev,
               libdcmtk2-dev,
               libfftw3-dev,
               libhdf5-dev,
               libpng12-dev,
Standards-Version: 3.9.5
Homepage: http://www.picsl.upenn.edu/ANTS/
Vcs-Git: git://git.debian.org/pkg-exppsy/ants.git
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/ants.git;a=summary

Package: ants
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Conflicts: gpe-conf
Recommends: environment-modules
Suggests: fsl, gridengine-client, r-base-core
Description: advanced normalization tools for brain and image analysis
 Advanced Normalization Tools (ANTS) is an ITK-based suite of
 normalization, segmentation and template-building tools for
 quantitative morphometric analysis. Many of the ANTS registration
 tools are diffeomorphic, but deformation (elastic and BSpline)
 transformations are available. Unique components of ANTS include
 multivariate similarity metrics, landmark guidance, the ability to
 use label images to guide the mapping and both greedy and space-time
 optimal implementations of diffeomorphisms. The symmetric
 normalization (SyN) strategy is a part of the ANTS toolkit as is
 directly manipulated free form deformation (DMFFD).
 .
 This package provides environment-modules configuration.
 Use 'module load ants' to make all cmdline tools available in your shell.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
uver = $(shell echo $(debver) | cut -d '-' -f 1,1 )

modulesfile = debian/ants.environment-modules

export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    export CFLAGS += -O0
else
    export CFLAGS += -O2
endif

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Exclude all heavy tests while building on slowish build
# bots/platforms
BOGOMIPS = $(shell awk '/^bogomips/{print $$3;}' /proc/cpuinfo | sed -ne '1s,\..*,,gp' )
CTEST_EXCLUDE = $(shell [ "$(BOGOMIPS)" -gt 2000 ] || echo "-E '^ANTS(_|PSE)'")

export SHELL=/bin/bash

# Default mega-rule
%:
	dh $@ --parallel


override_dh_auto_configure:
	dh_auto_configure -- \
		-DANTS_SUPERBUILD:BOOL=OFF \
		-DANTS_USE_GIT_PROTOC:BOOL=OFF \
		-DCOPY_SCRIPT_FILES_TO_BIN_DIR:BOOL=OFF \
		-DCMAKE_SKIP_RPATH:BOOL=OFF \
		-DUSE_SYSTEM_ITK:BOOL=ON \
		-DUSE_VTK:BOOL=OFF \
		-DBUILD_SHARED_LIBS:BOOL=ON \
		-DRUN_SHORT_TESTS:BOOL=ON \
		-DRUN_LONG_TESTS:BOOL=OFF \
		-DEXECUTABLE_OUTPUT_PATH:PATH=$(DESTBINDIR) \
		-DCMAKE_INSTALL_RPATH:STRING="/usr/lib/ants/lib" \
		--debug-output

%modules: %modules.in
	sed -e 's,$$UVERSION,$(uver),g' $< >| $@

override_dh_auto_build: $(modulesfile)
	dh_auto_build
	: Build manpages
	cd `/bin/ls -d obj-*/bin` && mkdir -p ../man && \
    for f in *; do \
	 help2man --name="part of ANTS registration suite" --version-string $(uver) \
	          --no-info --no-discard-stderr ./$$f >| ../man/$$f.1; \
     done


override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-*; \
	 ln -s ../debian/testdata ExternalData || : ; \
	 ctest --force-new-ctest-process $(CTEST_EXCLUDE)
else
	: # Skip unittests due to nocheck
endif

override_dh_auto_install:
	dh_auto_install
	: remove .so files 
	rm debian/ants/usr/lib/*.so
	: Move binaries under usr/lib/ants
	mv debian/ants/usr/bin/* debian/ants/usr/lib/ants
	: Symlink binaries of primary importance and with ants prefix into /usr/bin
	for fp in debian/ants/usr/lib/ants/{ants*,ANTS*,WarpImageMultiTransform,WarpTimeSeriesImageMultiTransform,Atropos,LaplacianThickness,joinfusion}; do \
		f=$$(basename $$fp); \
		dh_link usr/lib/ants/$$f usr/bin/$$f; \
	done
	: Install shell scripts
	install -t debian/ants/usr/lib/ants Scripts/*
	: Install modules file
	install -m 664 $(modulesfile) debian/ants/usr/share/modules/modulefiles/ants/$(uver)
	: Adjust ANTSPATH
	cd debian/ants/usr/lib/ants && sed -ie 's,\([^"=]*\(/bin/ants\|ANTS/release/bin\)\),/usr/lib/ants,g' *.sh *.pl && rm *.she *.ple
	: Install manpages
	dh_installman obj-*/man/*

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR) debian/ants.environment-modules

# upstream tests use some tiny dataset for tests, which
# they deposited online instead of keeping under the GIT
# Since the data size is small, we just package it along,
# but that would require first building ANTs
get_upstream_external_data:
	mkdir -p .ExternalData/MD5
	# TODO

## ants 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,10 @@
-cmake_minimum_required(VERSION 2.8.5)
-cmake_policy(VERSION 2.8.5)
+cmake_minimum_required(VERSION 2.8.9)
+cmake_policy(VERSION 2.8.9)
+
+find_program(CCACHE_PROGRAM ccache)
+if(CCACHE_PROGRAM)
+    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
+endif()
 
 set(LIBRARY_SOVERSION_INFO 2)
 set(LIBRARY_VERSION_INFO 2.1.0)
@@ -31,6 +36,9 @@
 option(${LOCAL_PROJECT_NAME}_INSTALL_DEVELOPMENT "Install development support include and libraries for external packages." OFF)
 mark_as_advanced(${LOCAL_PROJECT_NAME}_INSTALL_DEVELOPMENT)
 
+option(COPY_SCRIPT_FILES_TO_BIN_DIR "Copy the script files to the ANTS bin directory." OFF)
+mark_as_advanced(COPY_SCRIPT_FILES_TO_BIN_DIR)
+
 set(CPACK_PACKAGE_NAME "ANTs")
 set(CPACK_PACKAGE_VENDOR "CMake.org")
 set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - Advanced Normalization Tools")

=== Examples/CMakeLists.txt ===
## Note that the antsUtilities can always be built static.  It will then be linked
## Directly into the other libraries.
add_library(antsUtilities STATIC antsUtilities.cxx
            antsRegistrationTemplateHeader.cxx
            antsRegistration2DDouble.cxx antsRegistration2DFloat.cxx
            antsRegistration3DDouble.cxx antsRegistration3DFloat.cxx
            antsRegistration4DDouble.cxx antsRegistration4DFloat.cxx
            ../Utilities/ReadWriteData.cxx
            ../Utilities/antsCommandLineOption.cxx
            ../Utilities/antsCommandLineParser.cxx
            ANTsVersion.cxx
            ImageMathHelper.cxx ImageMathHelper2D.cxx  ImageMathHelper3D.cxx  ImageMathHelper4D.cxx
            )
target_link_libraries(antsUtilities ${ITK_LIBRARIES} )
install(TARGETS antsUtilities
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    COMPONENT RUNTIME_antsUtilities
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    COMPONENT RUNTIME_antsUtilities
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
    COMPONENT DEVELOPMENT_antsUtilities
  )

macro(STANDARD_ANTS_BUILD ANTS_FUNCTION_NAME EXTRA_LIBS)
  set( ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME} )

  add_library(l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}.cxx)
  SET_TARGET_PROPERTIES(l_${ANTS_FUNCTION_NAME} PROPERTIES
    SOVERSION ${LIBRARY_SOVERSION_INFO}  VERSION ${LIBRARY_VERSION_INFO})
  message(STATUS "${ANTS_FUNCTION_NAME} ${EXTRA_LIBS}")
  target_link_libraries(l_${ANTS_FUNCTION_NAME} antsUtilities ${EXTRA_LIBS} )
  configure_file( template_for_executables.cxx.in cli_${ANTS_FUNCTION_NAME}.cxx )
  add_executable( ${ANTS_FUNCTION_NAME} cli_${ANTS_FUNCTION_NAME}.cxx )
  target_link_libraries( ${ANTS_FUNCTION_NAME} l_${ANTS_FUNCTION_NAME} )

  install(TARGETS l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
    COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
    COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
    COMPONENT DEVELOPMENT_${ANTS_FUNCTION_NAME}
  )

endmacro()

#set(PROG_WITH_NO_FLAG simpleSynRegistration)
#add_executable(${PROG_WITH_NO_FLAG} ${PROG_WITH_NO_FLAG}.cxx)
#target_link_libraries(${PROG_WITH_NO_FLAG} antsUtilities ${ITK_LIBRARIES})


set(CORE_ANTS_APPS
  antsAffineInitializer
  antsJointFusion
  SurfaceBasedSmoothing
  CreateJacobianDeterminantImage
  ThresholdImage
  ResampleImage
  sccan
  N4BiasFieldCorrection
  N3BiasFieldCorrection
  KellyKapowski
  antsRegistration
  antsMotionCorrStats
  antsMotionCorr
  antsApplyTransforms
  LabelGeometryMeasures
  LabelClustersUniquely
  Atropos
  antsApplyTransformsToPoints
)

set(MORE_ANTS_APPS
    antsAI
    antsJointTensorFusion
    ImageMath
    iMath
    ANTS
    ANTSJacobian
    PrintHeader
    ResetDirection
    ANTSUseLandmarkImagesToGetAffineTransform
    ANTSUseLandmarkImagesToGetBSplineDisplacementField
    ANTSUseDeformationFieldToGetAffineTransform
    antsLandmarkBasedTransformInitializer
    LaplacianThickness
    SetOrigin
    SetSpacing
    SetDirectionByMatrix
    SurfaceCurvature
    ConvertScalarImageToRGB
    CreateWarpedGridImage
    MeasureImageSimilarity
    ConvertToJpg
    ConvertImage
    ConvertImagePixelType
    ConvertInputImagePixelTypeToFloat
    FitBSplineToPoints
    AverageTensorImages
    ImageSetStatistics
    MultiplyImages
    SmoothDisplacementField
    SmoothImage
    ClusterImageStatistics
    LabelOverlapMeasures
    LesionFilling
    MeasureMinMaxMean
    WarpImageMultiTransform
    ComposeMultiTransform
    MemoryTest
    PermuteFlipImageOrientationAxes
    ImageCompare
    ResampleImageBySpacing
    CopyImageHeaderInformation
    WarpTimeSeriesImageMultiTransform
    ExtractSliceFromImage
    ExtractRegionFromImage
    ExtractRegionFromImageByMask
    PasteImageIntoImage
    TileImages
    CreateTiledMosaic
    CreateImage
    DenoiseImage
    NonLocalSuperResolution
    WarpTensorImageMultiTransform
    ReorientTensorImage
    RebaseTensorImage
    KellySlater
    CreateDTICohort
    antsAlignOrigin
    antsMotionCorrDiffusionDirection
    antsSliceRegularizedRegistration
    ANTSIntegrateVectorField
    ANTSIntegrateVelocityField
    antsTransformInfo
    antsUtilitiesTesting
    AverageAffineTransform
    AverageAffineTransformNoRigid
    AverageImages
    simpleSynRegistration
    CompositeTransformUtil
    CreateDisplacementField
    ConvertTransformFile
    compareTwoTransforms
    SuperResolution
    TimeSCCAN
    TextureCooccurrenceFeatures
    TextureRunLengthFeatures
    ImageIntensityStatistics
    GetConnectedComponentsFeatureImages
    DeNrrd
    StackSlices
  )

foreach(ANTS_APP ${CORE_ANTS_APPS})
  STANDARD_ANTS_BUILD(${ANTS_APP} "")
endforeach()

if (BUILD_ALL_ANTS_APPS)
  foreach(ANTS_APP ${MORE_ANTS_APPS})
    STANDARD_ANTS_BUILD(${ANTS_APP} "")
  endforeach()
else(BUILD_ALL_ANTS_APPS)
  foreach(ANTS_APP ${MORE_ANTS_APPS})
    if(ANTS_BUILD_${ANTS_APP})
      STANDARD_ANTS_BUILD(${ANTS_APP} "")
    endif()
  endforeach()
endif(BUILD_ALL_ANTS_APPS)


if(USE_VTK)
set(VTK_ANTS_APPS
    # ConvertVectorFieldToVTK
    antsSurf
    antsVol
    GetMeshAndTopology
    CheckTopology
    WarpVTKPolyDataMultiTransform
    # FLATFEM
    # ConformalMapping
    # ANTSConformalMapping
  )

foreach(ANTS_APP ${VTK_ANTS_APPS})
  STANDARD_ANTS_BUILD(${ANTS_APP} "${VTK_LIBRARIES}")
endforeach()
endif(USE_VTK)

install(PROGRAMS ../Scripts/ANTSpexec.sh
     ../Scripts/antsASLProcessing.sh
     ../Scripts/antsAtroposN4.sh
     ../Scripts/antsBOLDNetworkAnalysis.R
     ../Scripts/antsBrainExtraction.sh
     ../Scripts/antsCorticalThickness.sh
     ../Scripts/antsIntermodalityIntrasubject.sh
     ../Scripts/antsIntroduction.sh
     ../Scripts/antsLaplacianBoundaryCondition.R
     ../Scripts/antsLongitudinalCorticalThickness.sh
     ../Scripts/antsJointLabelFusion.sh
     ../Scripts/antsMultivariateTemplateConstruction.sh
     ../Scripts/antsMultivariateTemplateConstruction2.sh
     ../Scripts/antsNetworkAnalysis.R
     ../Scripts/antsNeuroimagingBattery
     ../Scripts/antsRegistrationSyN.sh
     ../Scripts/antsRegistrationSyNQuick.sh
     ../Scripts/waitForPBSQJobs.pl
     ../Scripts/waitForSGEQJobs.pl
     ../Scripts/waitForXGridJobs.pl
     ../Scripts/waitForSlurmJobs.pl
                DESTINATION ${SCRIPTS_INSTALL_DIR}
                PERMISSIONS  OWNER_WRITE OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
                CONFIGURATIONS  Release
                COMPONENT SCRIPTS
        )

if( COPY_SCRIPT_FILES_TO_BIN_DIR )
  message( "-- Copy scripts." )
  file( GLOB SCRIPT_FILES "../Scripts/*.sh" )
  file( GLOB PSCRIPT_FILES "../Scripts/*.pl" )
  foreach( SCRIPT_FILE ${SCRIPT_FILES} )
    message( "  Copying ${SCRIPT_FILE} to ${CMAKE_CURRENT_BINARY_DIR}/../../bin/" )
    CONFIGURE_FILE( ${SCRIPT_FILE} ${CMAKE_CURRENT_BINARY_DIR}/../../bin/ COPYONLY )
  endforeach( SCRIPT_FILE )
  foreach( SCRIPT_FILE ${PSCRIPT_FILES} )
    message( "  Copying ${SCRIPT_FILE} to ${CMAKE_CURRENT_BINARY_DIR}/../../bin/" )
    CONFIGURE_FILE( ${SCRIPT_FILE} ${CMAKE_CURRENT_BINARY_DIR}/../../bin/ COPYONLY )
  endforeach( SCRIPT_FILE )
endif( COPY_SCRIPT_FILES_TO_BIN_DIR )

## Build test option
if(BUILD_TESTING)
    add_subdirectory(TestSuite)
endif(BUILD_TESTING)

set(CPACK_PACKAGE_NAME "ANTs")
set(CPACK_PACKAGE_VENDOR "CMake.org")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ANTs - Advanced Normalization Tools")
set(CPACK_PACKAGE_VERSION 2.1.0)
set(CPACK_PACKAGE_VERSION_MAJOR 2)
set(CPACK_PACKAGE_VERSION_MINOR 1)
set(CPACK_PACKAGE_VERSION_PATCH 0)
set(CPACK_PACKAGE_INSTALL_DIRECTORY "ANTS")
set(CPACK_BINARY_GENERATORS "DragNDrop TGZ TZ")
# This must always be last!
include(CPack)

=== Examples/TestSuite/CMakeLists.txt ===
--- 
+++ 
@@ -110,7 +110,7 @@
   --compareNumberOfPixelsTolerance 1000
 
   antsRegistrationTest
-  --dimensionality 3
+  -v --dimensionality 3
   --convergence 25x20x5 #numberOfIterations 2500
   --shrink-factors 1x1x1
   --smoothing-sigmas 0.1x0.1x0.1
@@ -131,7 +131,7 @@
   --compareNumberOfPixelsTolerance 1000
 
   antsRegistrationTest
-  --dimensionality 3
+  -v --dimensionality 3
   --convergence 25x20x5
   --shrink-factors 1x1x1
   --smoothing-sigmas 0.1x0.1x0.1
@@ -152,7 +152,7 @@
   --compareNumberOfPixelsTolerance 777
 
   antsRegistrationTest
-  --dimensionality 3
+  -v --dimensionality 3
   --convergence 25x20x5
   --shrink-factors 1x1x1
   --smoothing-sigmas 0.1x0.1x0.1
@@ -173,7 +173,7 @@
   --compareNumberOfPixelsTolerance 777
 
   antsRegistrationTest
-  --dimensionality 3
+  -v --dimensionality 3
   --convergence 25x20x5
   --shrink-factors 1x1x1
   --smoothing-sigmas 0.1x0.1x0.1
@@ -193,7 +193,7 @@
   --compareNumberOfPixelsTolerance 777
 
   antsRegistrationTest
-  --dimensionality 3
+  -v --dimensionality 3
   --convergence 25x20x5
   --shrink-factors 1x1x1
   --smoothing-sigmas 0.1x0.1x0.1
@@ -214,7 +214,7 @@
   --compareNumberOfPixelsTolerance 777
 
   antsRegistrationTest
-  --dimensionality 3
-  --convergence 25x20x5
-  --shrink-factors 1x1x1
-  --smoothing-sigmas 0.1x0.1x0.1
+  -v --dimensionality 3
+  --convergence 25x20x5
+  --shrink-factors 1x1x1
+  --smoothing-sigmas 0.1x0.1x0.1

=== debian/changelog ===
ants (2.2.0-1ubuntu1) artful; urgency=medium

  * Merge from Debian experimental.  Remaining changes:
    - reduce parallelism on amd64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 22 Aug 2017 18:36:57 +0200

ants (2.2.0-1) experimental; urgency=medium

  * New upstream release

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 23 May 2017 10:23:17 -0400

ants (2.1.0+git715-ge56f961-1) unstable; urgency=medium

  * New upstream snapshot from v2.1.0-715-ge56f961
  * Absorbing and acknowleding NMUs for 2.1.0-4
    (Thank you Mattia and Gianfranco!)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 09 Dec 2016 09:14:30 -0500

ants (2.1.0+git635-g0752c29-1) experimental; urgency=medium

  * New upstream snapshot from v2.1.0-635-g0752c29

 -- Yaroslav Halchenko <debian@onerussian.com>  Sun, 12 Jun 2016 12:21:41 -0400

ants (2.1.0-5ubuntu1) zesty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - reduce parallelism on amd64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 09 Mar 2017 14:05:10 +0100

ants (2.1.0-5) unstable; urgency=medium

  * joinfusion -> jointfusion symlink (Closes: #856941)

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 08 Mar 2017 19:05:12 -0500

ants (2.1.0-4.3ubuntu1) yakkety; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - reduce parallelism on amd64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 Aug 2016 12:06:22 +0200

ants (2.1.0-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove openjpeg from Build-Depends.  Closes: #826806

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 11 Aug 2016 08:47:06 +0000

ants (2.1.0-4.2ubuntu1) yakkety; urgency=medium

  * Try to fix build failure by reducing parallelism on amd64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Jul 2016 11:43:08 +0200

ants (2.1.0-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Really fix dcmtk dependency (Closes: #811166)
  * Bump std-version to 3.9.8.
  * Remove libpng12-dev alternative dependency.
  * Fix insecure VCS fields.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 16 Apr 2016 16:25:13 +0200

ants (2.1.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/5608ed64ee9993882e99781172568238933170d6.patch:
    fix build failure with new ITK (Closes: #817257)
  * Fix dcmtk dependency (Closes: #811166)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 14 Apr 2016 07:50:56 +0000

ants (2.1.0-4) unstable; urgency=medium

  * debian/control
    - removed first versioned libpng16-dev which is apparently still
      in experimental. So now libpng-dev virtual is the first among
      libpng build-depends (Closes: #810165)

 -- Yaroslav Halchenko <debian@onerussian.com>  Sat, 09 Jan 2016 22:55:52 -0500

ants (2.1.0-3) unstable; urgency=medium

  * debian/control
    - add libpng16-dev | libpng-dev to build-depends
      (Closes: #810165, #809860)
  * debian/{control,rules}
    - drop any VTK dependency for now and still build without VTK support
      (Closes: #798166)
  * if builds/uploaded fine, it means that all the compatibility issues with
    g++-5 were resolved (Closes: #777771)

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 07 Jan 2016 08:45:47 -0500

=== debian/control ===
--- 
+++ 
@@ -1,30 +1,25 @@
 Source: ants
 Section: science
 Priority: extra
-Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
-X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
+Maintainer: NeuroDebian Team <team@neuro.debian.net>
 Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
 Build-Depends: debhelper (>= 9),
                help2man, cmake,
-               libopenjpeg-dev, libinsighttoolkit4-dev (>> 4.7.0~), uuid-dev,
-               tcl-vtk | libvtk5-dev (<< 5.8),
-               python-vtk | libvtk5-dev (<< 5.8),
-               libvtk-java | libvtk5-dev (<< 5.8),
-               libvtk5.8-qt4 | libvtk5-dev (<< 5.8),
+               libinsighttoolkit4-dev (>> 4.7.0~), uuid-dev,
                libboost-dev,
                libtiff-dev,
-               libdcmtk2-dev,
+               libdcmtk-dev | libdcmtk2-dev,
                libfftw3-dev,
                libhdf5-dev,
-               libpng12-dev,
-Standards-Version: 3.9.5
+               libpng-dev
+Standards-Version: 3.9.8
 Homepage: http://www.picsl.upenn.edu/ANTS/
-Vcs-Git: git://git.debian.org/pkg-exppsy/ants.git
-Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/ants.git;a=summary
+Vcs-Git: https://anonscm.debian.org/git/pkg-exppsy/ants.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-exppsy/ants.git
 
 Package: ants
 Architecture: any
-Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: gpe-conf
 Recommends: environment-modules
 Suggests: fsl, gridengine-client, r-base-core

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,10 @@
 export  https_proxy=http://127.0.0.1:9/
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
+ifeq ($(DEB_HOST_ARCH),amd64)
+  export DEB_BUILD_OPTIONS=parallel=2
+endif
 
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
     export CFLAGS += -O0
@@ -77,7 +81,7 @@
 	: Move binaries under usr/lib/ants
 	mv debian/ants/usr/bin/* debian/ants/usr/lib/ants
 	: Symlink binaries of primary importance and with ants prefix into /usr/bin
-	for fp in debian/ants/usr/lib/ants/{ants*,ANTS*,WarpImageMultiTransform,WarpTimeSeriesImageMultiTransform,Atropos,LaplacianThickness,joinfusion}; do \
+	for fp in debian/ants/usr/lib/ants/{ants*,ANTS*,WarpImageMultiTransform,WarpTimeSeriesImageMultiTransform,Atropos,LaplacianThickness,jointfusion}; do \
 		f=$$(basename $$fp); \
 		dh_link usr/lib/ants/$$f usr/bin/$$f; \
 	done

=== debian/watch ===
version=3
opts="uversionmangle=s/rc/~rc/g,filenamemangle=s/.*\/(.*)/ants-$1\.tar\.gz/" \
  http://github.com/stnava/ANTs/releases .*archive/v([\d\.a-z]+).tar.gz

## ants 2.4.3+dfsg

=== debian/changelog ===
ants (2.4.3+dfsg-1) unstable; urgency=medium

  * New upstream release 2.4.3+dfsg:
    - Build is successful on amd64 (Closes: #872741, #884710, #909833)
    - Building against insighttoolkit5 (Closes: #1018921)
  * Removing d/docs, there are no more documentation files to install
  * Skipping tests relying on external data with unclear licensing
  * Rewriting d/copyright
  * Repacking to exclude a non-free file
  * Adding myself as Uploader
  * Adding B-D on two itk modules: adaptiveDenoising and
    genericLabelInterpolator
  * Adding linker flags to build against libitkadaptivedenoising-dev
  * Adding a header to the up_lower_cc_3_test_i386_precision patch
  * Removing d/s/include-binaries
  * Removing legacy patches
  * Honouring the RPATH fixed in debian/rules
  * Adding perl:Depends to the Depends: field in d/control
  * Installing shared libs in a private directory, installing shell scripts
    without the .sh extension
  * debian/rules:
    - Hardening
    - Revising the creation process of man pages by overriding dh_installman
    - Removing get_upstream_external_data target
    - Keeping the built .so files in the binary package
    - Updating paths after changes in last upstream versions (Closes: #905417)
    - Polishing by removing useless lines or stanzas
  * Revising and documenting Lintian overrides
  * Fixing minor spelling mistakes

  [ Andreas Tille ]
  * Take over package into Debian Med team maintenance
  * Remove debian/gbp.conf
  * Raising Standards-Version to 4.7.0:
    - debhelper-compat 13 (routine-update)
    - Secure URI in copyright format (routine-update)
    - Rules-Requires-Root: no (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Do not parse d/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * watch file standard 4 (routine-update)
  * Build-Depends specifies only libpng-dev (Closes: #819427)
  * Fix watchfile to detect new versions on Github (routine-update)

  [ Dimitri Papadopoulos Orfanos ]
  * SVN → Git
  * Update README.source

 -- Pierre Gruet <pgt@debian.org>  Tue, 03 Sep 2024 21:31:29 +0200
